﻿
Imports System.Drawing.Imaging

Public Class Form1
  Dim Order As Integer = 520
  Dim BlockSize As Integer = 0
  Dim Bmap As New System.Drawing.Bitmap(Order, Order)
  Dim gr As Graphics = Graphics.FromImage(Bmap)
  Dim CellState(Order, Order) As Byte
  Dim Ant1 As Ant
  Dim AntBrush As New SolidBrush(Color.Black)
  Dim Generation As Integer
  Dim TextAlgorithm(10, 10) As String
  Dim NumericAlgorithm(10, 10) As Integer
  Dim Running As Boolean = False
  Dim ColourBrush(8) As SolidBrush

  Private Structure Ant
    Dim X As Integer
    Dim Y As Integer
    Dim Heading As Integer
    Dim State As Integer
  End Structure

  Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    ColourBrush(0) = New SolidBrush(Color.White)
    ColourBrush(1) = New SolidBrush(Color.Red)
    ColourBrush(2) = New SolidBrush(Color.Blue)
    ColourBrush(3) = New SolidBrush(Color.Green)
    ColourBrush(4) = New SolidBrush(Color.Yellow)
    ColourBrush(5) = New SolidBrush(Color.Magenta)
    ColourBrush(6) = New SolidBrush(Color.Cyan)
    ColourBrush(7) = New SolidBrush(Color.Gray)
    ComboBox1.Items.Add("Langtons Ant")
    ComboBox1.Items.Add("Diamond")
    ComboBox1.Items.Add("Square")
    ComboBox1.Items.Add("Patterned Square")
    ComboBox1.Items.Add("Zulu Shield")
    ComboBox1.Items.Add("Woven Mat")
    ComboBox1.SelectedIndex = 0
    RadioButton5.Checked = True
    Timer1.Interval = 1
    RadioButton1.Checked = True
    PictureBox1.Image = Bmap
  End Sub

  Private Sub WriteAlgorithm()
    TextBox1.Text = TextAlgorithm(0, 0)
    TextBox2.Text = TextAlgorithm(0, 1)
    TextBox3.Text = TextAlgorithm(0, 2)
    TextBox4.Text = TextAlgorithm(1, 0)
    TextBox5.Text = TextAlgorithm(1, 1)
    TextBox6.Text = TextAlgorithm(1, 2)
    TextBox7.Text = TextAlgorithm(2, 0)
    TextBox8.Text = TextAlgorithm(2, 1)
    TextBox9.Text = TextAlgorithm(2, 2)
  End Sub
  Private Function ExtractAlgorithm()
    TextAlgorithm(0, 0) = TextBox1.Text
    TextAlgorithm(0, 1) = TextBox2.Text
    TextAlgorithm(0, 2) = TextBox3.Text
    TextAlgorithm(1, 0) = TextBox4.Text
    TextAlgorithm(1, 1) = TextBox5.Text
    TextAlgorithm(1, 2) = TextBox6.Text
    TextAlgorithm(2, 0) = TextBox7.Text
    TextAlgorithm(2, 1) = TextBox8.Text
    TextAlgorithm(2, 2) = TextBox9.Text
    Return GetNumericAlgorithm()
  End Function
  Private Sub GetTextAlgorithm()
    For i As Integer = 0 To 2
      For j As Integer = 0 To 2
        TextAlgorithm(i, j) = ConvertNumberToText(NumericAlgorithm(i, j))
      Next
    Next
  End Sub
  Private Function GetNumericAlgorithm()
    For i As Integer = 0 To 2
      For j As Integer = 0 To 2
        NumericAlgorithm(i, j) = ConvertTextToNumber(TextAlgorithm(i, j))
        If NumericAlgorithm(i, j) < -1 Then MsgBox("Invalid string") : Return False
      Next
    Next
    Return True
  End Function
  Private Function ConvertTextToNumber(text As String) As Integer
    If text.Length = 0 Then Return -1
    If text.Length < 3 Then Return -5
    Dim n As Integer = 0
    Select Case text.Substring(2, 1)
      Case "L" : n = 0
      Case "R" : n = 1
      Case "F" : n = 2
      Case "B" : n = 3
      Case Else : Return -2
    End Select
    Select Case text.Substring(1, 1)
      Case "P"
      Case "Q" : n += &H10
      Case "R" : n += &H20
      Case "S" : n += &H30
      Case "T" : n += &H40
      Case "U" : n += &H50
      Case "V" : n += &H60
      Case "W" : n += &H70
      Case Else : Return -3
    End Select
    Select Case text.Substring(0, 1)
      Case "A"
      Case "B" : n += &H100
      Case "C" : n += &H200
      Case "D" : n += &H300
      Case "E" : n += &H400
      Case "F" : n += &H500
      Case "G" : n += &H600
      Case "H" : n += &H700
      Case Else : Return -4
    End Select
    Return n
  End Function
  Private Function ConvertNumberToText(n As Integer) As String
    Dim t As String = ""
    Select Case n And &HF00
      Case &H0 : t = "A"
      Case &H100 : t = "B"
      Case &H200 : t = "C"
      Case &H300 : t = "D"
      Case &H400 : t = "E"
      Case &H500 : t = "F"
      Case &H600 : t = "G"
      Case &H700 : t = "H"
    End Select
    Select Case n And &HF0
      Case &H0 : t &= "P"
      Case &H10 : t &= "Q"
      Case &H20 : t &= "R"
      Case &H30 : t &= "S"
      Case &H40 : t &= "T"
      Case &H50 : t &= "U"
      Case &H60 : t &= "V"
      Case &H70 : t &= "W"
    End Select
    Select Case n And &HF
      Case &H0 : t &= "L"
      Case &H1 : t &= "R"
      Case &H2 : t &= "F"
      Case &H3 : t &= "B"
    End Select
    Return t
  End Function

  Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
    For a As Integer = 1 To 100 / BlockSize
      UpdateAnt(Running)
    Next
    PictureBox1.Invalidate()
  End Sub

  Private Sub ClearButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
    Reset()
  End Sub
  Private Sub Reset()
    For j As Integer = 0 To Order - 1
      For i As Integer = 0 To Order - 1
        CellState(i, j) = 0
      Next
    Next
    Ant1.X = Order / 2
    Ant1.Y = Order / 2
    Ant1.Heading = 0
    Ant1.State = 0
    gr.Clear(Color.Gainsboro)
    Generation = 0 : Label1.Text = "Generation:" & Str(Generation)
    PlotAnt()
    PictureBox1.Invalidate()
  End Sub
  Private Sub ReStartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
    If Running Then
      StopTimer()
    Else
      If ExtractAlgorithm() Then StartTimer()
    End If
  End Sub
  Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
    If Running Then
      StopTimer()
    Else
      Reset()
      If ExtractAlgorithm() Then StartTimer()
    End If
  End Sub
  Private Sub OneStepButton_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
    If ExtractAlgorithm() Then
      UpdateAnt(True)
      PictureBox1.Invalidate()
    End If
  End Sub

  Private Sub UpdateAnt(F)
    If Not F Then Exit Sub
    If NumericAlgorithm(Ant1.State, CellState(Ant1.X, Ant1.Y)) < 0 Then
      Debug.Print(Str(Ant1.State) & Str(CellState(Ant1.X, Ant1.Y)))
      StopTimer() : MsgBox("Undefined cell state")
      Exit Sub
    End If
    TurnAnt()
    WriteCell()
    WriteState()
    MoveAnt()
    Generation += 1 : Label1.Text = "Generation:" & Str(Generation)
  End Sub
  Private Sub WriteCell()
    CellState(Ant1.X, Ant1.Y) = (NumericAlgorithm(Ant1.State, CellState(Ant1.X, Ant1.Y)) >> 4) And &HF
    PlotBlock(ColourBrush(CellState(Ant1.X, Ant1.Y)), Ant1.X, Ant1.Y)
  End Sub
  Private Sub WriteState()
    Ant1.State = (NumericAlgorithm(Ant1.State, CellState(Ant1.X, Ant1.Y)) >> 8) And &HF
  End Sub
  Private Sub MoveAnt()
    If CheckBox1.Checked Then ' wrap around
      Select Case Ant1.Heading
        Case 0 : Ant1.Y -= 1 : If Ant1.Y < 0 Then Ant1.Y = Order - 1
        Case 1 : Ant1.X -= 1 : If Ant1.X < 0 Then Ant1.X = Order - 1
        Case 2 : Ant1.Y += 1 : If Ant1.Y > Order - 1 Then Ant1.Y = 0
        Case 3 : Ant1.X += 1 : If Ant1.X > Order - 1 Then Ant1.X = 0
      End Select
    Else
      Select Case Ant1.Heading
        Case 0 : Ant1.Y -= 1 : If Ant1.Y < 0 Then Ant1.Y = 0 : StopTimer()
        Case 1 : Ant1.X -= 1 : If Ant1.X < 0 Then Ant1.X = 0 : StopTimer()
        Case 2 : Ant1.Y += 1 : If Ant1.Y > Order - 1 Then Ant1.Y = 0 : StopTimer()
        Case 3 : Ant1.X += 1 : If Ant1.X > Order - 1 Then Ant1.X = 0 : StopTimer()
      End Select
    End If
    PlotAnt()
    If CellState(Ant1.X, Ant1.Y) = -1 Then MsgBox("Undefined state reached")
  End Sub
  Private Sub TurnAnt()
    Select Case NumericAlgorithm(Ant1.State, CellState(Ant1.X, Ant1.Y)) And 3
      Case 0 ' turn left
        Ant1.Heading = (Ant1.Heading + 1) Mod 4
      Case 1 ' turn right
        Ant1.Heading = (Ant1.Heading + 3) Mod 4
      Case 2 ' straight on
      Case 3 ' turn back
        Ant1.Heading = (Ant1.Heading + 2) Mod 4
      Case Else ' straight on
    End Select
  End Sub
  Private Sub StopTimer()
    Button3.Text = "Start afresh"
    Button2.Enabled = True
    Button4.Enabled = True
    Timer1.Stop()
    Running = False
  End Sub
  Private Sub StartTimer()
    Button3.Text = "Stop"
    Button2.Enabled = False
    Button4.Enabled = False
    Timer1.Start()
    Running = True
  End Sub
  Private Sub PlotAnt()
    PlotBlock(AntBrush, Ant1.X, Ant1.Y)
  End Sub
  Private Sub PlotBlock(ByVal b, ByVal x, ByVal y)
    x = BlockSize * (x - Order \ 2) + Order \ 2
    y = BlockSize * (y - Order \ 2) + Order \ 2
    If x < 0 Or y < 0 Then Exit Sub
    If x >= Order - BlockSize Or y >= Order - BlockSize Then Exit Sub
    gr.FillRectangle(b, x, y, BlockSize, BlockSize)
  End Sub
  Private Sub RadioButton1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton1.CheckedChanged, RadioButton2.CheckedChanged, RadioButton3.CheckedChanged, RadioButton4.CheckedChanged
    Select Case True
      Case RadioButton1.Checked : BlockSize = 1
      Case RadioButton2.Checked : BlockSize = 2
      Case RadioButton3.Checked : BlockSize = 4
      Case RadioButton4.Checked : BlockSize = 8
    End Select
    Reset()
  End Sub
  Private Sub ComboBox1_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
    ' Algorithm(AntState,CellState)
    ResetAlgorithm()
    Select Case ComboBox1.SelectedIndex
      Case 0 ' Langtons Ant
        TextAlgorithm(0, 0) = "AQL"
        TextAlgorithm(0, 1) = "APR"
        NumericUpDown1.Value = 1
        NumericUpDown2.Value = 2
      Case 1 ' Diamond
        TextAlgorithm(0, 0) = "AQB"
        TextAlgorithm(0, 1) = "ARF"
        TextAlgorithm(0, 2) = "ARL"
        NumericUpDown1.Value = 1
        NumericUpDown2.Value = 3
      Case 2 ' Square
        TextAlgorithm(0, 0) = "AQL"
        TextAlgorithm(0, 1) = "BQR"
        TextAlgorithm(1, 0) = "BPL"
        TextAlgorithm(1, 1) = "AQR"""
        NumericUpDown1.Value = 2
        NumericUpDown2.Value = 2
      Case 3 ' Square pattern
        TextAlgorithm(0, 0) = "BQL"
        TextAlgorithm(0, 1) = "APR"
        TextAlgorithm(1, 0) = "APR"
        TextAlgorithm(1, 1) = "BQL"
        NumericUpDown1.Value = 2
        NumericUpDown2.Value = 2
      Case 4 ' Zulu Shield
        TextAlgorithm(0, 0) = "BPR"
        TextAlgorithm(0, 1) = "BQR"
        TextAlgorithm(0, 2) = "AQR"
        TextAlgorithm(1, 0) = "BRR"
        TextAlgorithm(1, 1) = "BRR"
        TextAlgorithm(1, 2) = "APL"
        NumericUpDown1.Value = 2
        NumericUpDown2.Value = 3
      Case 5 ' Woven mat
        TextAlgorithm(0, 0) = "BQL"
        TextAlgorithm(0, 1) = "BPR"
        TextAlgorithm(0, 2) = "ARL"
        TextAlgorithm(1, 0) = "CQR"
        TextAlgorithm(1, 1) = "CQL"
        TextAlgorithm(1, 2) = "CRL"
        TextAlgorithm(2, 0) = "BRR"
        TextAlgorithm(2, 1) = "CPL"
        TextAlgorithm(2, 2) = "AQL"
        NumericUpDown1.Value = 3
        NumericUpDown2.Value = 3
    End Select
    WriteAlgorithm()
    GetNumericAlgorithm()
  End Sub
  Private Sub SaveButton_Click(sender As System.Object, e As System.EventArgs) Handles Button5.Click
    Dim filename As String
    If SaveFileDialog1.ShowDialog = DialogResult.OK Then
      filename = SaveFileDialog1.FileName
      If Not filename.EndsWith(".jpg") And Not filename.EndsWith(".jpeg") Then filename &= ".jpg"
      Bmap.Save(filename, ImageFormat.Jpeg)
    End If
  End Sub

  Private Sub RandomiseButton6_Click(sender As System.Object, e As System.EventArgs) Handles Button6.Click
    Dim a As Integer = NumericUpDown1.Value ' number of internal states
    Dim b As Integer = NumericUpDown2.Value ' number of cell states
    Dim c As Integer = 2 ' number of actions
    Select Case True
      Case RadioButton6.Checked : c = 3
      Case RadioButton7.Checked : c = 4
    End Select
    ResetAlgorithm()
    Dim R As New Random
    For i As Integer = 0 To a - 1
      For j As Integer = 0 To b - 1
        NumericAlgorithm(i, j) = R.Next(a) << 8 Or R.Next(b) << 4 Or R.Next(c)
        TextAlgorithm(i, j) = ConvertNumberToText(NumericAlgorithm(i, j))
        'Debug.Print(Str(i) & Str(j) & " " & TextAlgorithm(i, j) & " " & Hex(NumericAlgorithm(i, j)))
      Next
    Next
    WriteAlgorithm()
    PrintAlgorithm()
    Reset()
    StartTimer()
  End Sub

  Private Sub PrintAlgorithm()
    Dim a As Integer = NumericUpDown1.Value ' number of internal states
    Dim b As Integer = NumericUpDown2.Value ' number of cell states
    Dim s As String = ""
    For i As Integer = 0 To a - 1
      For j As Integer = 0 To b - 1
        s &= TextAlgorithm(i, j) & " "
      Next
      s &= ": "
    Next
    My.Computer.Clipboard.SetText(s)
  End Sub

  Private Sub ResetAlgorithm()
    For i As Integer = 0 To 2
      For j As Integer = 0 To 2
        NumericAlgorithm(i, j) = -1
        TextAlgorithm(i, j) = ""
      Next
    Next
  End Sub

  Private Sub NumericUpDown1_ValueChanged(sender As System.Object, e As System.EventArgs) Handles NumericUpDown1.ValueChanged, NumericUpDown2.ValueChanged
    TextBox1.Enabled = True
    TextBox2.Enabled = NumericUpDown2.Value > 1
    TextBox3.Enabled = NumericUpDown2.Value > 2
    TextBox4.Enabled = NumericUpDown1.Value > 1
    TextBox5.Enabled = NumericUpDown1.Value > 1 And NumericUpDown2.Value > 1
    TextBox6.Enabled = NumericUpDown1.Value > 1 And NumericUpDown2.Value > 2
    TextBox7.Enabled = NumericUpDown1.Value > 2
    TextBox8.Enabled = NumericUpDown1.Value > 2 And NumericUpDown2.Value > 1
    TextBox9.Enabled = NumericUpDown1.Value > 2 And NumericUpDown2.Value > 2
  End Sub

  Private Sub Button7_Click(sender As System.Object, e As System.EventArgs) Handles Button7.Click
    Help.ShowDialog()
  End Sub
End Class
